/*
 * Created by SharpDevelop.
 * User: Stephen
 * Date: 7/31/2007
 * Time: 1:09 PM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using System.Management;
using System.Xml.Serialization;

namespace MgmtWithWMI
{
	[Serializable]
	public class WMI1
	{
		public String networkInterfaces;
		public String ipRoutes;
		
		public WMI1()
		{
			networkInterfaces = getNetworkInterfaceDetails();
			ipRoutes = getIPRouteTable();
		}
		
		public string getNetworkInterfaceDetails()
		{
			string netInterfaceData = String.Empty;
			
			// Use WMI technology to retrieve the interface details
			ManagementObjectSearcher searcher =
				new ManagementObjectSearcher(
                  "select * from Win32_PerfRawData_Tcpip_NetworkInterface");

			foreach(ManagementObject adapterObject in searcher.Get())
            {
				netInterfaceData += "Adapter name: " + adapterObject["Name"] + "\r\n";
			}
			
            return netInterfaceData;			
		}
		
		public string getIPRouteTable()
		{
			string ipRouteData = String.Empty;
			
			// Use WMI technology to retrieve the interface details
			ManagementObjectSearcher searcher =
				new ManagementObjectSearcher(
                  "select * from Win32_IP4RouteTable");

			foreach(ManagementObject adapterObject in searcher.Get())
            {
				ipRouteData += "Destination: " + adapterObject["Destination"] + ", " +
					"NextHop: " + adapterObject["NextHop"] + "\r\n";
			}
			
            return ipRouteData;			
		}		
	}
}
